<?php
# Date: 20.02.2022 (16:21)
namespace Insallah\Map;

class MapData
{
    private array $map;
    private int $startx;
    private int $starty;
    private const DEF_XY = [
        'map' => ['x' => 5, 'y' => 5],
        'map2' => ['x' => 2, 'y' => 4],
    ];
    private static string $filename;

    public function __construct(?string $mapName)
    {
        if (empty($mapName)) {
            $mapName = 'map';
        }
        self::$filename = dirname(getcwd()) . '/resources/maps/' . htmlspecialchars($mapName) . '.csv';
        $handle = fopen(self::$filename, 'r');
        while (($data = fgetcsv($handle, 1000, ';')) !== false) {
            $this->map[] = $data;
        }
        fclose($handle);
        $this->startx = self::DEF_XY[$mapName]['x'];
        $this->starty = self::DEF_XY[$mapName]['y'];
    }

    /**
     * @return array
     */
    public function getMap(): array
    {
        return $this->map;
    }

    /**
     * @return int
     */
    public function getStartx(): int
    {
        return $this->startx;
    }

    /**
     * @return int
     */
    public function getStarty(): int
    {
        return $this->starty;
    }

    public static function drawFullMap()
    {
        $file = fopen(self::$filename, 'r');
        echo '<table>';
        while (($data = fgetcsv($file, null, ';')) !== false) {
            echo '<tr>';
            foreach ($data as $i) {
                if (empty($i)) {
                    $i = 'end';
                }
                echo "<td><img src='../resources/img/$i.png' width='25px' height='25px' alt='map'></td>";
            }
            echo "</tr>\n";
        }
        echo '</table>';
        fclose($file);
    }
}